// =====================================================================================================================
//  fennec, a free and open source game engine
//  Copyright © 2025 - 2026  Medusa Slockbower
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <https://www.gnu.org/licenses/>.
// =====================================================================================================================

#ifndef FENNEC_TEST_MATH_RELATIONAL_H
#define FENNEC_TEST_MATH_RELATIONAL_H
#include "../../test.h"

namespace fennec::test
{

	inline void fennec_test_math_relational()
	{
		fennec_test_run(fennec::lessThan(vec3(3, 2, 1), vec3(1, 2, 3)),         bvec3(false, false, true));
		fennec_test_run(fennec::lessThanEqual(vec3(3, 2, 1), vec3(1, 2, 3)),    bvec3(false, true, true));

		fennec_test_spacer(1);

		fennec_test_run(fennec::greaterThan(vec3(3, 2, 1), vec3(1, 2, 3)),      bvec3(true, false, false));
		fennec_test_run(fennec::greaterThanEqual(vec3(3, 2, 1), vec3(1, 2, 3)), bvec3(true, true, false));

		fennec_test_spacer(1);

		fennec_test_run(fennec::equal(vec3(3, 2, 1), vec3(1, 2, 3)),            bvec3(false, true, false));
		fennec_test_run(fennec::notEqual(vec3(3, 2, 1), vec3(1, 2, 3)),         bvec3(true, false, true));

		fennec_test_spacer(1);

		fennec_test_run(not(bvec3(true, false, true)),                          bvec3(false, true, false));
		fennec_test_run(fennec::all(bvec3(true, true, true)),                   true);
	}

}

#endif // FENNEC_TEST_MATH_RELATIONAL_H
